better support for systems with no pxe
[automated-distro-installer] / fai / config / scripts / GRUB_PC / 11-ian
index e27e394e8ac3509032d1ab194fc8c35812ebee92..199e4f860745ac55c1eb4ac23fc3509d08cfcb58 100755 (executable)
@@ -4,40 +4,50 @@ set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 if [[ $EUID != 0 ]]; then
-    echo "$0: error: expected to be root."
-    exit 1
+  echo "$0: error: expected to be root."
+  exit 1
 fi
 
+
 if ! type -t fcopy &>/dev/null; then
-    sudo apt-get -y install fai-client
+  sudo apt-get -y install fai-client
+fi
+
+chroot $FAI_ROOT bash <<'EOFOUTER'
+debconf-set-selections <<EOF
+kexec-tools kexec-tools/load_kexec boolean false
+EOF
+apt-get install -y pxe-kexec
+EOFOUTER
+
+# note: # fcopy -i = ignore nonmatching class error, always return 0.
+# this is also done by FABASE/10-misc by default.
+fcopy -ir /root
+if ifclass STABLE_BOOTSTRAP; then
+  fcopy -ri /etc/systemd/system
+  chroot $FAI_ROOT bash <<'EOFOUTER'
+systemctl enable fai_check.service
+EOFOUTER
+  exit 0
 fi
 
 dir=/q/root/shadow
 fai_shadow=$FAI/distro-install-common/shadow
 if [[ ! -e $dir && -e $fai_shadow ]]; then
-    mkdir -p $dir
-    mount -o bind $fai_shadow $dir
+  mkdir -p $dir
+  mount -o bind $fai_shadow $dir
 fi
 $FAI/distro-install-common/end
 
-if ifclass STABLE || ifclass LINODESTABLE; then
-    fcopy -M /etc/apt/preferences
-fi
 
-if ifclass DEBIAN; then
-    fcopy -M /etc/apt/preferences.d/unstable
-fi
-fcopy -riM /etc/apt/sources.list.d
+# these get copied in an earlier stage by fai, but leaving it here since
+# I run this as a single post-fai script to update things that have changed.
+fcopy -ri /etc/apt/preferences.d
+fcopy -ri /etc/apt/sources.list.d
 $ROOTCMD apt-get update
 
 
 
-# note:
-# fcopy -i = ignore nonmatching class error, always return 0.
-
-# for lj, this will be empty and fail
-fcopy -riM /home/ian/.ssh
-
 rm -f $FAI_ROOT/etc/apt/sources.list
 
 chroot $FAI_ROOT bash <<'EOF'
@@ -81,4 +91,3 @@ EOF
 for g in plugdev audio video cdrom; do
     $ROOTCMD usermod -a -G $g traci
 done
-